/********************************************************************************
*
*--------------------------------------------------------------------------------
*--        Copyright Magnus Nilsson and SPL, Griffith University 2001          --
*--------------------------------------------------------------------------------
*--
*--
*--
*-- The copyright of the source program herein is the property of Magnus Nilsson 
*-- and Signal Processing Laboratory, Griffith University, Australia. 
*-- The program may be used and/or copied only with the written permission from 
*-- Magnus Nilsson and Signal Processing Laboratory, Griffith University or in 
*-- accordance with theterms and conditions stipulated in the agreement/contract 
*-- under which the program has been supplied.
*--
*--
*--------------------------------------------------------------------------------
*--------------------------------------------------------------------------------
*--
*-- Project    : VQ-speaker verification
*-- Title      : Speaker Verification
*-- File name  : RecordSpeech.java
*-- Revision   : pa1
*-- Date       : 25-09-2001
*-- Prepared   : Magnus Nilsson
*-- Responsible:
*-- Description: 
*-- -----------------------------------------------------------------------------
*-- Revision history: (all revisions included)                                 --
*-- -----------------------------------------------------------------------------
*-- Rev:    Initials:    Date:       Modification                              --
*-- -----------------------------------------------------------------------------
*-- pa1     MN           25-09-01    Final revision                            --
*-- -----------------------------------------------------------------------------
********************************************************************************/
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.Line2D;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.Enumeration;
import java.io.*;
import javax.sound.sampled.*;
import java.awt.font.*;
import java.text.*;
import java.applet.*;
import java.net.*;
import java.lang.Math;
import java.lang.System;

public class RecordSpeech {

    String fileName = "untitled.wav";
	String userName[] = new String[100];
	int users;
    String errStr;
    File file, file1, ljud;
    Vector lines = new Vector();
	URL u;
	AudioClip a;
	String username, datUser;
    final int bufSize = 16384;
	boolean silence = false;
	boolean done = false;
	double thresholdPower = 0;
	int numberOfFrames; //Approx 10 times as many frames as entrys when train, 5 times as many for test
	int samplesPerFrame = 240; //30ms of speech @ Fs = 8kHz
	double one[][];
	boolean add, ok = false;
	

	int startfilter = 1;		// CF of 100 Hz (filter starts at 0 Hz)
	int endfilter = 19;			// CF of 3482 Hz (filter ends at 4000 Hz)
	int Nfilters = endfilter - startfilter +1;

	double mfcc[][];
	double reydct[][];

	//Define recording, 8000kHz, 16-bits, PCM signed, mono
	float rate = 8000;
    int sampleSize = 16;
    String signedString = "signed";
    boolean bigEndian = true;
    int channels = 1;
	AudioFormat.Encoding encoding = AudioFormat.Encoding.PCM_SIGNED;

	interactiveFrame frameWindow;

	ParallelPort lpt1 = new ParallelPort(0x378); // 0x378 is the base address for Parallel printer port LPT1		
	
    Record record = new Record();
	Mfcc classMfcc = new Mfcc();
	SplitCodebook splitCodebook = new SplitCodebook();
	Verify verify = new Verify();
    AudioInputStream audioInputStream;
	AudioFormat format = new AudioFormat(encoding, rate, sampleSize, channels, (sampleSize/8)*channels, rate, bigEndian);

	public void makeTriang() {
		classMfcc.triangFilter();
	}

	public boolean recording(String user, boolean add_verify) {
		//add_verify, case true => add
		add = add_verify;
		datUser = user;
		int tid;
		username = user + ".wav";
		Thread Q;
        file = null;				
        fileName = "untitled.wav";                           
		//Add user to the system
		if (add == true) {
			numberOfFrames = 320;
			reydct= new double[numberOfFrames][Nfilters];
			mfcc = new double[numberOfFrames][Nfilters-1];
			one = new double[numberOfFrames][samplesPerFrame];
			try {Thread.sleep(1000);}
	        catch(InterruptedException e) { }
			record.start();
			try {Thread.sleep(8000);}
	        catch(InterruptedException e) { }
		}
		//Verify user
		else {
			numberOfFrames = 160;
			reydct= new double[numberOfFrames][Nfilters];
			mfcc = new double[numberOfFrames][Nfilters-1];
			one = new double[numberOfFrames][samplesPerFrame];
			try {Thread.sleep(1000);}
	        catch(InterruptedException e) { }
			record.start();
			try {Thread.sleep(5000);}
			catch(InterruptedException e) { }
		}
        lines.removeAllElements();  
		record.stop();
		AudioP();

		//Wait before closing window when done recording
		if (users > 0) {
			tid = 1000;
		}
		else {
			tid = 8000;
		}
		try {Thread.sleep(tid);}
		catch(InterruptedException e) { }
		if (ok == true) {
			return true;
		}
		else {
			return false;
		}
	}

	public void recordingSilence() {
		Thread Q;
        file = null;
		record.start();
        fileName = "untitled.wav";                           
		try {Thread.sleep(2000);}
        catch(InterruptedException e) { }
        lines.removeAllElements();  
		record.stop();		
	}

	public void AudioP() {
		TargetDataLine line;
        DataLine.Info info = new DataLine.Info(TargetDataLine.class, format);
                        
        if (!AudioSystem.isLineSupported(info)) {
			System.out.println("Line matching " + info + " not supported.");
            return;
        }
        try {
            line = (TargetDataLine) AudioSystem.getLine(info);				
			line.open(format, line.getBufferSize());
        } catch (LineUnavailableException ex) { 
			System.out.println("Unable to open the line: " + ex);
            return;
        } catch (SecurityException ex) { 
            System.out.println("Error: " + ex);  
            return;
        } catch (Exception ex) { 
            System.out.println("Error: " + ex);
            return;
		}

        line.start();
		
		try {
			u = new URL("file:" + System.getProperty("user.dir") + "/sound/ding.wav");
		} 
		catch (MalformedURLException e) {
			System.err.println(e.getMessage());
		}
		a = Applet.newAudioClip(u);
		a.play();
        line.stop();
        line.close();
        line = null;
	}

	public void showInteraction(String title, int toDo, boolean delay) {		
		frameWindow = new interactiveFrame(title, toDo); 
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		int w = 288;
		int h = 216;
		frameWindow.setLocation(screenSize.width/2 - w/2, screenSize.height/2 - h/2);
		frameWindow.setSize(w, h);
		frameWindow.setVisible(true);
		if (delay == true) {
			Thread Q;
			try {Thread.sleep(4000);}
			catch(InterruptedException e) { }
			frameWindow.setVisible(false);
		}
	}

	public void paraport(int abyte) { 		
		lpt1.write(abyte); // write a byte to the port
	}
	
    public void createAudioInputStream(File file, boolean updateComponents) {
		if (file != null && file.isFile()) {
            try {
                this.file = file;
                errStr = null;
                audioInputStream = AudioSystem.getAudioInputStream(file);
                fileName = file.getName();
		    } 
			catch (Exception ex) { 
                reportStatus(ex.toString());
            }
        } 
		else {
            reportStatus("Audio file required.");
        }
    }

    public void saveToFile(String name, AudioFileFormat.Type fileType) {
        if (audioInputStream == null) {
            reportStatus("No loaded audio to save");
            return;
        } 
		else if (file != null) {
            createAudioInputStream(file, false);
        }

        // reset to the beginnning of the recorded data
        try {
            audioInputStream.reset();
        } 
		catch (Exception e) { 
            reportStatus("Unable to reset stream " + e);
            return;
        }

        File file = new File(fileName = name);
        try {
            if (AudioSystem.write(audioInputStream, fileType, file) == -1) {
                throw new IOException("Problems writing to file");
            }
        } 
		catch (Exception ex) { 
			reportStatus(ex.toString()); 
		}        
    }
        
    private void reportStatus(String msg) {
        if ((errStr = msg) != null) {
            System.out.println(errStr);            
        }
    }

	/** 
     * Reads data from the input channel and writes to the output stream
     */
    class Record implements Runnable {

        TargetDataLine line;
        Thread thread;

        public void start() {			
            errStr = null;
            thread = new Thread(this);
            thread.setName("Record");
            thread.start();
        }

        public void stop() {
            thread = null;
        }
        
        private void shutDown(String message) {
            if ((errStr = message) != null && thread != null) {
                thread = null;                                               
                System.err.println(errStr);                
            }
        }

        public void run() {
            // define the required attributes for our line, 
            // and make sure a compatible line is supported.

            DataLine.Info info = new DataLine.Info(TargetDataLine.class, format);
                        
            if (!AudioSystem.isLineSupported(info)) {
                shutDown("Line matching " + info + " not supported.");
                return;
            }

            //get and open the target data line for record.

            try {
                line = (TargetDataLine) AudioSystem.getLine(info);
				line.open(format, line.getBufferSize());
            } 
			catch (LineUnavailableException ex) { 
                shutDown("Unable to open the line: " + ex);
                return;
            } 
			catch (SecurityException ex) { 
                shutDown(ex.toString());
                return;
            } 
			catch (Exception ex) { 
                shutDown(ex.toString());
                return;
            }

            //play back the recorded audio data
            ByteArrayOutputStream out = new ByteArrayOutputStream();
            int frameSizeInBytes = format.getFrameSize();
            int bufferLengthInFrames = line.getBufferSize() / 8;
            int bufferLengthInBytes = bufferLengthInFrames * frameSizeInBytes;
            byte[] data = new byte[bufferLengthInBytes];
            int numBytesRead;
            
            line.start();

            while (thread != null) {
                if((numBytesRead = line.read(data, 0, bufferLengthInBytes)) == -1) {
                    break;
                }
                out.write(data, 0, numBytesRead);
            }

            //we reached the end of the stream.  stop and close the line.
            line.stop();
            line.close();
            line = null;

            // stop and close the output stream
            try {
                out.flush();
                out.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }

            // load bytes into the audio input stream for playback
            byte audioBytes[] = out.toByteArray();
            ByteArrayInputStream bais = new ByteArrayInputStream(audioBytes);			
            audioInputStream = new AudioInputStream(bais, format, audioBytes.length / frameSizeInBytes);
          
            try {
                audioInputStream.reset();
            } 
			catch (Exception ex) { 
                ex.printStackTrace(); 
                return;
            }

			// Divide into frames of 240 samples
			int i = 0, s = 0, p = 0;			
			double power = 0;			

			if (silence == false) {
				while (i < audioBytes.length) {				
					power = power + Math.pow((audioBytes[i]*256 + audioBytes[i+1]), 2);
					i = i+2;
				}
				thresholdPower = 1.5 * ((samplesPerFrame*power) / (i/2));
				silence = true;
				System.out.println("\nRecording silence, threshold power: " + thresholdPower);				
				System.out.println();
			}

			else if (silence == true) {	
				double testing = 0; 
				boolean recordedFrame = false;
				while (i < audioBytes.length) {				
					one[p][s] = (audioBytes[i]*256 + audioBytes[i+1]);
					power = power + Math.pow(one[p][s], 2); //calculate power
					i = i+2;
					s = s+1;
																			
					if (s > (samplesPerFrame - 1)) {	
						if (power > thresholdPower) {
							p = p+1;							
							recordedFrame = true;
							i = i - 120*2; //Since 16 bits and overlapping with 50%
							testing = testing + power;
							if (p > (numberOfFrames - 1)) {
								i = audioBytes.length + 1;
								//ok recording!!
								System.out.println("OK recording, power = " + (testing/p));
								System.out.println("Threshold = " + thresholdPower);
								ok = true;								
								classMfcc.mkMfcc();	
								//If adding user, save it also to a wavefile
								if (add == true) {
									String wavename = "wavefiles/" + username;
									saveToFile(wavename, AudioFileFormat.Type.WAVE);	
								}																
							}						
						}
						else if (p > 1 && recordedFrame == true ) {
							i = i - samplesPerFrame; //Since 16 bits and overlapping with 50%
							recordedFrame = false;							
						}
						s = 0;
						power = 0;
					}
				}
				if (ok == false) {
					System.out.println("NOT OK recording");
					System.out.println("Threshold = " + thresholdPower);
					System.out.println("Correct frames: " + p);
					showInteraction("Bad recording", 7, true);
					//closeInteraction();
				}				
				System.out.println();					
			}
		}		
    } // End class Record

	class Mfcc {
		
		int N = 1024; //FFT length
		int frameLength = 240;
		// Triangular windowing, center frequencies:	
		int[] Lo = new int[]{0, 0 ,100, 200, 300, 400, 500, 600, 700, 800, 900, 1000, 1150, 1320, 1520, 1750, 2000, 2300, 2640, 3040, 3500};
		int[] Ce = new int[]{0, 100, 200, 300, 400, 500, 600, 700, 800, 900, 1000, 1150, 1320, 1520, 1750, 2000, 2300, 2640, 3040, 3500, 4000};
		int[] Up = new int[]{100, 200, 300, 400, 500, 600, 700, 800, 900, 1000, 1150, 1320, 1520, 1750, 2000, 2300, 2640, 3040, 3500, 4000, 4600};					
		double F[][] = new double[Nfilters+1][N];
		int startFilter[] = new int[Nfilters+1]; //Start and stop value for each triangular filter array
		int stopFilter[] = new int[Nfilters+1]; //Start and stop value for each triangular filter array
		float Fs = 8000; //Sampling freq.
		float N2 = N;
		float freqconst = Fs/N2;	
		int i = startfilter;
		int f = 0;
		double binconst[][] = new double[5][frameLength];
		double R[] = new double[frameLength];
		double bin[] = new double[frameLength];
		double maxAmpBin[][] = new double[numberOfFrames][10];
		boolean starta = false;
		
		int start = 7;
		int stop = 29;

		public void triangFilter() {
			for (int f = 0; f < 5; f++) {
				for (int d = start; d < stop; d++) { 
					binconst[f][d] = 1;
				}
				start = start + 22;
				stop = stop + 22;
			}
			while (i < (endfilter + 1)) {	
				if (f > (N/2)-1) {
					F[i][f] = 0;				
					stopFilter[i] = f;
					starta = false;
					i = i + 1;
					f = 0;										
				}
				else if (f*freqconst < Lo[i]) {
					F[i][f] = 0;
					f = f + 1;
				}
				else if (f*freqconst == Ce[i]) {
					F[i][f] = 1;
					f = f + 1;
				}
				else if (f*freqconst < Ce[i]) {
					if (starta == false) {
						startFilter[i] = f;						
						starta = true;
					}
					F[i][f] = (f*freqconst-Lo[i])/(Ce[i]-Lo[i]);
					f = f + 1;
					
				}
				else if ((f*freqconst > Ce[i]) && (f*freqconst < Up[i])) {
					F[i][f] = (Up[i]-f*freqconst)/(Up[i]-Ce[i]);
					f = f + 1;				
				}
				else if (f*freqconst > Up[i]) {
					F[i][f] = 0;	
					stopFilter[i] = f;
					starta = false;
					i = i + 1;
					f = 0;									
				}				
				else {
					F[i][f] = 0;
					stopFilter[i] = f;
					starta = false;
					i = i + 1;
					f = 0;				
				}
			}
		}

		public void mkMfcc() {	
			int L = 1, Lx, r, rx;
			double ar, ai, br, bi, cr, ci, dr, di;
			double hamm; //Hamming window
			double pi = Math.PI;		
			double t = Math.log(N)/Math.log(4); 			
		
			double imagSignal[] = new double[frameLength];
			double realSignal[] = new double[frameLength];
			double xr[], xi[], yr[], yi[], power[];		
			xr = new double[N+1];
			xi = new double[N+1];		
			yr = new double[N+1];		
			yi = new double[N+1];		
			power = new double[N];	
			
			for (int ee = 0; ee < numberOfFrames ; ee = ee + 1) {
				for (int rr = 0; rr < frameLength; rr = rr + 1)	{
					realSignal[rr] = one[ee][rr];
					imagSignal[rr] = 0;
				}

				// Zero padding and Hammingwindow of the signal
				for (int s = 0; s < (N + 1) ; s = s + 1) {			
					xr[s] = 0;
					xi[s] = 0;
				}		
				for (int s = 0; s < frameLength ; s = s + 1) {
					hamm = 0.54-0.46*Math.cos(2*pi*(s+1)/(frameLength-1));
					xr[s+1] = realSignal[s] * hamm;
					xi[s+1] = imagSignal[s] * hamm;
				}	
				
				L = 1;
				
				// Radix-4 FFT algorithm
				for (int q = 1; q < (t + 1); q = q + 1) {
					L = 4 * L;	
					r = N/L;
					Lx = L/4;
					rx = 4*r;
					for (int s = 0; s < N + 1 ; s = s + 1) {
						yr[s] = xr[s];
						yi[s] = xi[s];
					}
					for (int j = 0; j < Lx; j = j + 1) {
						for (int k = 0; k < r; k = k + 1) {
							ar = yr[(j*rx) + (k + 1)];
							ai = yi[(j*rx) + (k + 1)];
							br = yr[(j*rx) + (r + k + 1)]*Math.cos((2*pi*j)/L) + yi[(j*rx) + (r + k + 1)]*Math.sin((2*pi*j)/L);
							bi = yi[(j*rx) + (r + k + 1)]*Math.cos((2*pi*j)/L) - yr[(j*rx) + (r + k + 1)]*Math.sin((2*pi*j)/L);
							cr = yr[(j*rx) + (2*r) + (k + 1)]*Math.cos((2*pi*2*j)/L) + yi[(j*rx) + (2*r) + (k + 1)]*Math.sin((2*pi*2*j)/L);
							ci = yi[(j*rx) + (2*r) + (k + 1)]*Math.cos((2*pi*2*j)/L) - yr[(j*rx) + (2*r) + (k + 1)]*Math.sin((2*pi*2*j)/L);
							dr = yr[(j*rx) + (3*r) + (k + 1)]*Math.cos((2*pi*3*j)/L) + yi[(j*rx) + (3*r) + (k + 1)]*Math.sin((2*pi*3*j)/L);
							di = yi[(j*rx) + (3*r) + (k + 1)]*Math.cos((2*pi*3*j)/L) - yr[(j*rx) + (3*r) + (k + 1)]*Math.sin((2*pi*3*j)/L);

							xr[(j*r) + (k + 1)] = ar + cr + br + dr;
							xi[(j*r) + (k + 1)] = ai + ci + bi + di;
							xr[((j + Lx)*r) + (k + 1)] = ar - cr + bi - di;
							xi[((j + Lx)*r) + (k + 1)] = ai - ci - br + dr;
							xr[((j + 2*Lx)*r) + (k + 1)] = ar + cr - br - dr;
							xi[((j + 2*Lx)*r) + (k + 1)] = ai + ci - bi - di; 
							xr[((j + 3*Lx)*r) + (k + 1)] = ar - cr - bi + di;
							xi[((j + 3*Lx)*r) + (k + 1)] = ai - ci + br - dr; 					
						}
					} 
				}

				// Find magnitude and square it to get power (ie. omit the sqrt operation in magnitude)		
				for (int s=0; s<N; s = s + 1) {
					power[s] = xr[s+1]*xr[s+1] + xi[s+1]*xi[s+1];
				}			
				
				// Apply filterbanks
				double mfb[] = new double[Nfilters];
				double sum;
				for (int g = 1; g < 20; g = g + 1) {
					sum = 0;										
					for (int p = (startFilter[g]); p < (stopFilter[g]) ; p=p+1) {
						sum = sum + (F[g][p] * power[p]);
					}		
					mfb[g-1] = Math.log(sum);
				}			

				// DCT for decorrelation Reynold's DCT (p 12)
				// Get rid of the first one of these coeff.
				double cepweight[] = new double[]{0,1.0000, 3.8824, 6.7647, 9.6471,12.5294,15.4118,18.2941,21.1765,24.0588,26.9412,29.8235,32.7059,35.5882,38.4706,41.3529,44.2353,47.1176,50.0000};						
				for(int ii=0; ii<Nfilters; ii = ii + 1) {
					sum = 0;
					for(int j=0; j<Nfilters; j++) {
						sum = sum + mfb[j] * Math.cos(ii * (j-0.5) * pi / Nfilters);
					}
					reydct[ee][ii] = cepweight[ii] * sum/Nfilters;
				}
			}

			for (int z = 0; z < numberOfFrames ; z = z + 1)	{			
				for (int g = 1; g < Nfilters; g = g + 1) {
					mfcc[z][g-1] = reydct[z][g];		
				}						
			}
	
			System.out.println("Feature extraction finished");
			//Adding user or verifying user			
			if (add == true) {
				//Make codebook
				splitCodebook.mkCodebook();				
				//Interact with user
				System.out.println("\nComputation finished, user added");
				showInteraction("Added", 1, true);				
			}
			else {
				//Verification process					
				Thread Q;				
				boolean correct = verify.verifyUser();
				if (correct == true) {
					System.out.print("\nYou are the correct user: " + datUser);
					paraport(240); // write a byte to the port, i.e 11110000					
					showInteraction("Correct user", 2, true);					
				}
				else { 
					System.out.print("\nYou are not the correct user: " + datUser);
					paraport(15); // write a byte to the port, i.e 
					showInteraction("Imposter", 3, true);
				}	
				//Wait extra 4 sec before swithching off the parallel port thing
				try {Thread.sleep(4000);}
				catch(InterruptedException e) { }
				paraport(0); // write a byte to the port
			}			
		}
	}


	//Class codebook
	class SplitCodebook {		
	
		//Size of codebook
		int numberOfFrames = 320;
		int numberOfDim = 18;		//Number of dim of feature vector
		int numberOfEntries = 32;	//Number of entries in codebook
		double oldCentroid[] = new double[numberOfDim];
		double codebook[][] = new double[numberOfEntries][numberOfDim];

		//'Pointers' to the MFCC values
		int mfccPointers[][] = new int [numberOfEntries][numberOfFrames];
		int numOfValidVectors[] = new int[numberOfEntries];

		//Init dist variables.
		double distOld = 0;
		double distNew = 0;
		double minDist[] = new double[numberOfFrames];	
		int closestCentroid = 0;

		//init level and sum
		int level = 1, p;
		double sum;

		//Dead centroids
		boolean deadCentroid[] = new boolean[numberOfEntries];
		int maxVector, maxIndex;

		double numberOfFramesD = 320;
		boolean centroidCalc;


		public void mkCodebook() {

			level = 1;
			p = 0; //how many times dead centroids??
			centroidCalc = true;

			System.out.println("Start making codebook");

			//Init = codebook[0][:] = mean(MFCC)
			for (int t = 0; t < numberOfDim; t++) {
				sum = 0;
				for (int p = 0; p < numberOfFrames ; p++) {
					sum = sum + mfcc[p][t];  
				}
				codebook[0][t] = sum / numberOfFramesD;
			}

			while (level < numberOfEntries) {
				//Split the old code entries
				for (int i = 0; i < level; i++)	{
					for (int j = 0; j < numberOfDim; j++) {
						oldCentroid[j] = codebook[i][j];
						codebook[i][j] = oldCentroid[j] + 0.001;
						codebook[i+level][j] = oldCentroid[j] - 0.001;
					}						
				}
				level = level*2;							

				//loop for ten times
				for (int d = 0; d < 10; d++) {	
					for (int y = 0; y < numberOfEntries; y++) {
						numOfValidVectors[y] = 0;				  
					}

					//Nearest neighbour vector - centroid.			
					for (int p = 0; p < numberOfFrames; p++) {
						distNew = 0;
						distOld = 999999999;
						for (int t = 0; t < level; t++) {
							for (int x = 0; x < numberOfDim; x++) {
								distNew = distNew + Math.abs(mfcc[p][x] - codebook[t][x]);
							}	
							if (distNew < distOld) {
								distOld = distNew;
								closestCentroid = t;												
							}					
							distNew = 0;
						}						
						mfccPointers[closestCentroid][(numOfValidVectors[closestCentroid])] = p;
						numOfValidVectors[closestCentroid] ++;				  
					}
					
					maxVector = 0;
					maxIndex = 0;
					//Calculate mean of every cloud and update the centroids
					for (int z = 0; z < level; z++)	{						
						if (numOfValidVectors[z] < 2) {
							System.out.print("\nFor centroid " + z);
							System.out.print(" less than 2 valid neighbours => dead centroid\n");
							deadCentroid[z] = true;														
						}
						else {				
							if (numOfValidVectors[z] > maxVector) {
								maxVector = numOfValidVectors[z];
								maxIndex = z;
							}
							deadCentroid[z] = false;
							for (int t = 0; t < numberOfDim; t++) {
								sum = 0;
								for (int p = 0; p < numOfValidVectors[z]; p++) {
									sum = sum + mfcc[(mfccPointers[z][p])][t];  
								}
								codebook[z][t] = sum / numOfValidVectors[z];							
							}
						}
					}

					//Take care of "dead centroids"
					for (int r = 0; r < level; r++) {
						if (deadCentroid[r] == true) {
							for (int t = 0; t < numberOfDim; t++) {								
								codebook[r][t] = codebook[maxIndex][t] - 0.001;
								codebook[maxIndex][t] = codebook[maxIndex][t] + 0.001;
							}
							r = level;
							if (d > 1) {
								d = d - 1;
								//How many time dead centroids
								p ++;
								if (p > 10)	{
									level = numberOfEntries;
									System.out.println("Bad data, record again!!!");
									showInteraction("Bad recording", 7, true);
									centroidCalc = false;
								}
							}
						}							
					}				
				}
			}			

			//Calculation of the codebook ok!
			if (centroidCalc = true) {

				//Add one user to the userlist				
				userName[users] = datUser;
				users++;

				//Randomaccesfile with codebook entries
				String first = "user/codebook/" + datUser + ".codebook";
				try	{
					RandomAccessFile file = new RandomAccessFile(first, "rw");					
					for (int i = 0; i < numberOfEntries; i++) {
						for (int j = 0; j < numberOfDim; j++) {
							file.writeDouble(codebook[i][j]);
						}
					}			
					file.close();
				} catch (IOException ex) {
					ex.printStackTrace(); 
					return;		
				}	

				//Write output from DCT
				String userMFCC = "user/mfcc/" + datUser + ".mfcc";
				//Randomaccesfile			
				try	{
					RandomAccessFile file = new RandomAccessFile(userMFCC, "rw");							
					for (int z = 0; z < numberOfFrames ; z = z + 1)	{			
						for (int g = 0; g < Nfilters-1; g = g + 1) {
							file.writeDouble(mfcc[z][g]);		
						}								
					}
					file.close();
				} catch (IOException ex) {
					ex.printStackTrace(); 
					return;		
				}				
				
				//Textfile with userinfo
				try	{					
					String namn = "user/userinfo.info";
					File outputFile = new File(namn);       
					FileWriter out = new FileWriter(outputFile);
					for (int i = 0; i < users; i++)	{
						out.write(userName[i] + "\n");
					}	        
					out.close();
				} catch (IOException ex) {
					ex.printStackTrace(); 
					return;		
				}	
			}
		}
	}

	//Class Verify
	class Verify {	

		int compareWith = 10;
		int codebookEntrys = 32;
		int codebookDimensions = 18;
		int numberOfVerifyFrames = 160;
		double claimant;
		double imposter;
		double ratio;
		double verifyCodebook[][] = new double[codebookEntrys][codebookDimensions];
		String claim, impost;
		
		public boolean verifyUser() {
			//open file with codebook for claimed user, put in a matrix			
			claim = "user/codebook/" + datUser + ".codebook";
			try	{
				RandomAccessFile file = new RandomAccessFile(claim, "rw");				
				for (int i = 0; i < codebookEntrys; i++) {
					for (int j = 0; j < codebookDimensions; j++) {
						verifyCodebook[i][j] = file.readDouble();
					}
				}			
				file.close();
			} catch (IOException ex) {
				ex.printStackTrace(); 		
			}
			claimant = euclidianDistance();

			//Open one out of int: compareWith persons codebooks, defenitly imposters.
			imposter = 0;
			for (int k = 0; k < compareWith; k++) {					
				impost = "cohort/" + (k+1) + ".dat";
				try	{
					RandomAccessFile file = new RandomAccessFile(impost, "rw");				
					for (int i = 0; i < codebookEntrys; i++) {
						for (int j = 0; j < codebookDimensions; j++) {
							verifyCodebook[i][j] = file.readDouble();
						}
					}			
					file.close();
				} catch (IOException ex) {
					ex.printStackTrace(); 		
				}
				imposter = imposter + euclidianDistance();
			}

			imposter = imposter/compareWith;

			ratio = Math.pow((claimant*claimant)/imposter,4);
			System.out.print("\nRatio: " + ratio);

			boolean correct = false;
			if (ratio < 3E22) {
				correct = true;
			}
			return correct;
		}


		//Function that calculates the euclidian distance between two matrixes
		public double euclidianDistance() {
			double distNew, distOld, distIn = 0, distance = 0;
			for (int p = 0; p < numberOfVerifyFrames; p++) {
				distNew = 0;
				distOld = 999999999;
				for (int t = 0; t < codebookEntrys ; t++) {
					distNew = 0;
					for (int x = 0; x < codebookDimensions; x++) {
						distNew = distNew + Math.pow(Math.abs(mfcc[p][x] - verifyCodebook[t][x]),2);
					}	
					if (distNew < distOld) {
						distOld = distNew;						
					}
					distIn = distIn + distOld;					
				}		
				distance = distance + distIn;
				distIn = 0;
			}
			return distance;
		}		
	}	

	public class interactiveFrame extends Frame {

		JPanel[] dialogPanels = new JPanel[1];
		TextField text1 = new TextField(20);

		Icon addIcon = new ImageIcon("images/added.gif");
		Icon yesIcon = new ImageIcon("images/true.gif");
		Icon noIcon = new ImageIcon("images/imposter.gif");
		Icon helpIcon = new ImageIcon("images/help.gif");
		Icon masterIcon = new ImageIcon("images/master.gif");
		Icon creditIcon = new ImageIcon("images/credit.gif");
		Icon norecordIcon = new ImageIcon("images/norecord.gif");
		Icon overwriteIcon = new ImageIcon("images/overwrite.gif");
		Icon nouserIcon = new ImageIcon("images/nouser.gif");


		JTextPane jtextpane = new JTextPane();

		interactiveFrame(String title, int whatToDo){ 			
			super(title);			
			for(int i=0;i<dialogPanels.length;++i)
			dialogPanels[i] = new JPanel();
			setLayout(new GridLayout(1,1));

			dialogPanels[0].setLayout(new GridLayout(1,1));
			dialogPanels[0].add(jtextpane);
			if (whatToDo == 1) {
				jtextpane.insertIcon(addIcon);
			}
			else if (whatToDo == 2)	{
				jtextpane.insertIcon(yesIcon);
			}
			else if (whatToDo == 3) {
				jtextpane.insertIcon(noIcon);
			}
			else if (whatToDo == 4)	{
				jtextpane.insertIcon(helpIcon);
			}
			else if (whatToDo == 5)	{
				jtextpane.insertIcon(masterIcon);
			}
			else if (whatToDo == 6)	{
				jtextpane.insertIcon(creditIcon);
			}
			else if (whatToDo == 7)	{
				jtextpane.insertIcon(norecordIcon);
			}
			else if (whatToDo == 8)	{
				jtextpane.insertIcon(overwriteIcon);
			}
			else if (whatToDo == 9)	{
				jtextpane.insertIcon(nouserIcon);
			}
			jtextpane.setEditable(false);
			jtextpane.setMargin(new Insets(0,0,0,0));
			
			for(int i=0;i<dialogPanels.length;++i) add(dialogPanels[i]);

			addWindowListener(new DialogWindowHandler());		
		}

		public class DialogWindowHandler extends WindowAdapter {
			public void windowClosing(WindowEvent e) {
				setVisible(false);
			}
		}
	}
}